import React from 'react';
import { SelectProps, SelectOption } from './types';
declare function SelectWithRef<T extends SelectOption>({ className, listClassName, closeOnSelect, disabled, variant, selectAllLabel, metadata, multiple, onSearchChange, onSelect, onListVisibilityChange, options, renderEmptyState, renderTrigger, optionType, searchable, searchAutofocus, searchInitialValue, searchNoResultsLabel, searchPlaceholder, selectedOptions, triggerLabel, outline, autoFocus, triggerId, creatableOptions, isClearable, highlightedText, isLoading, submitOptions, }: SelectProps<T>, ref: React.Ref<HTMLDivElement>): JSX.Element;
declare namespace SelectWithRef {
    var displayName: string;
}
/**
 * According to this article: https://fettblog.eu/typescript-react-generic-forward-refs/
 */
export declare const Select: <T extends SelectOption>(props: SelectProps<T> & {
    ref?: React.Ref<HTMLDivElement> | undefined;
}) => ReturnType<typeof SelectWithRef>;
export default Select;
